﻿
Imports System.IO
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports Steema.TeeChart.Styles
Imports Steema.TeeChart
Imports System.Collections
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization


Public Class Form1
    ' Implements ICloneable

    Private tChartBoxPlot As New Steema.TeeChart.TChart
    Private labels(4) As String


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load


        ' The labels for horizontal axis
        labels(0) = "A"
        labels(1) = "B"
        labels(2) = "C"
        labels(3) = "D"

        CreateBoxPlot()

    End Sub


    Private Sub CreateBoxPlot()
        '================
        ' Create BoxPlot
        '================

        ' The title for vertical axis
        Dim Ylabel(0) As String
        Ylabel(0) = "Y Title"
        tChartBoxPlot.Axes.Left.Title.Lines = Ylabel
        tChartBoxPlot.Axes.Left.Title.Text = Ylabel(0)
        tChartBoxPlot.Axes.Left.Title.Visible = True

        tChartBoxPlot.Legend.Visible = False
        tChartBoxPlot.Aspect.View3D = False
        tChartBoxPlot.Size = New System.Drawing.Size(315, 246)

        ' Initiate
        tChartBoxPlot.Series.Clear()
        tChartBoxPlot.Axes.Bottom.Labels.Items.Clear()

        ' Set titles of graph
        tChartBoxPlot.Header.Text = "Test"
        tChartBoxPlot.Header.Visible = True

        ' Set ticks, minimum and maximum of axis
        tChartBoxPlot.Axes.Bottom.MinorTickCount = 0
        tChartBoxPlot.Axes.Left.MinorTickCount = 0

        tChartBoxPlot.Axes.Left.AutomaticMinimum = True
        tChartBoxPlot.Axes.Left.AutomaticMaximum = True

        tChartBoxPlot.Axes.Bottom.Labels.Font.Size = 11
        tChartBoxPlot.Axes.Left.Labels.Font.Size = 11

        For i As Int16 = 0 To 3

            Dim boxplot As New Steema.TeeChart.Styles.Box(tChartBoxPlot.Chart)
            Dim Graphdata(5) As Double


            boxplot.WhiskerPen.Width = 2
            boxplot.WhiskerPen.Color = Color.Blue
            boxplot.Box.Pen.Color = Color.Black
            boxplot.Box.Pen.Width = 2
            boxplot.Box.Visible = True
            boxplot.Box.Brush.Solid = True
            boxplot.Box.Brush.Color = Color.White
            boxplot.Box.Gradient.Visible = False
            boxplot.MedianPen.Color = Color.Red
            boxplot.MedianPen.Width = 2
            boxplot.MedianPen.Style = DashStyle.Solid
            boxplot.MedianPen.Visible = True
            boxplot.LinePen.Color = Color.Black
            boxplot.MildOut.Pen.Color = Color.Black
            boxplot.MildOut.Style = PointerStyles.Circle
            boxplot.MildOut.Visible = False
            boxplot.ExtrOut.Pen.Color = Color.Black
            boxplot.ExtrOut.Style = PointerStyles.Star
            boxplot.ExtrOut.Visible = False
            boxplot.Title = labels(i)
            boxplot.Position = i



            boxplot.Marks.Arrow.Color = Color.Transparent
            boxplot.Marks.Series.ValueFormat = "0.000"
            boxplot.Marks.ArrowLength = 7
            boxplot.Marks.AutoSize = True
            boxplot.Marks.Visible = False
            boxplot.Marks.Style = MarksStyles.Value

            tChartBoxPlot.Axes.Bottom.MinimumOffset = (boxplot.Box.HorizSize / 2) + 25
            tChartBoxPlot.Axes.Bottom.MaximumOffset = (boxplot.Box.HorizSize / 2) + 25


            For j = 0 To 5
                Graphdata(j) = CInt(Math.Ceiling(Rnd() * 10))
            Next
            boxplot.UseCustomValues = True
            boxplot.Add(Graphdata)
            boxplot.Median = Graphdata.Average
            boxplot.Quartile1 = Graphdata.Average - 1
            boxplot.Quartile3 = Graphdata.Average + 1
            boxplot.AdjacentPoint1 = 1
            boxplot.AdjacentPoint3 = 9
            tChartBoxPlot.Axes.Bottom.Labels.Items.Add(i, boxplot.Title)
            tChartBoxPlot.Series.Add(boxplot)

        Next

        Panel1.Controls.Add(tChartBoxPlot)

    End Sub

    Private Sub Button_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Save.Click
        tChartBoxPlot.Export.Template.Save("Boxplot")

    End Sub

    Private Sub Button_Load_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Load.Click
        Panel1.Controls.Clear()

        tChartBoxPlot.Import.Template.Load("Boxplot")

        Panel1.Controls.Add(tChartBoxPlot)
    End Sub

    Private Sub Button_Reset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Reset.Click
        Panel1.Controls.Clear()

        CreateBoxPlot()
    End Sub


    Private Sub ChkBox_InvertXAxis_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkBox_InvertXAxis.CheckedChanged

        If ChkBox_InvertXAxis.Checked = True Then
            tChartBoxPlot.Axes.Bottom.Inverted = True
        Else
            tChartBoxPlot.Axes.Bottom.Inverted = False
        End If


    End Sub

    Private Sub Chkbox_InvertYAxis_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Chkbox_InvertYAxis.CheckedChanged
        If Chkbox_InvertYAxis.Checked = True Then
            tChartBoxPlot.Axes.Left.Inverted = True
        Else
            tChartBoxPlot.Axes.Left.Inverted = False
        End If
    End Sub

    Private Sub Editor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Editor.Click
        Dim editor1 As Steema.TeeChart.Editor = New Steema.TeeChart.Editor(tChartBoxPlot)
        editor1.Width = Convert.ToInt32(800)
        editor1.Height = Convert.ToInt32(500)
        editor1.ShowModal()
    End Sub
End Class
